const bodyFactory = template => {
  return message => {
    return template(`
			super(MESSAGE);
			this.name = this.constructor.name;
			this.message = MESSAGE;
			if (typeof Error.captureStackTrace === 'function') {
				Error.captureStackTrace(this, this.constructor);
			} else {
				this.stack = new Error(MESSAGE).stack;
			}
		`)({
      MESSAGE: message
    });
  };
};

var index = (({
  types: t,
  template
}) => {
  const body = bodyFactory(template);
  return {
    visitor: {
      ClassDeclaration(path) {
        var _ref, _path$node$superClass, _constructorPath$get;

        let message;
        const isError = (_ref = ((_path$node$superClass = path.node.superClass) === null || _path$node$superClass === void 0 ? void 0 : _path$node$superClass.name) === 'Error') !== null && _ref !== void 0 ? _ref : false;
        const hasConstructor = path.node.body.body.some(({
          kind
        }) => kind === 'constructor');

        if (!isError) {
          return;
        }

        if (!hasConstructor) {
          message = t.identifier('message');
          path.get('body').unshiftContainer('body', [t.classMethod('constructor', t.identifier('constructor'), [message], t.blockStatement(body(message)))]);
          return;
        }

        const constructorPath = path.get('body.body').find(path => path.node.kind === 'constructor');
        const [extractedMessage] = (_constructorPath$get = constructorPath.get('params')) !== null && _constructorPath$get !== void 0 ? _constructorPath$get : [];
        message = extractedMessage;

        if (typeof message === 'undefined') {
          message = t.identifier('message');
          constructorPath.unshiftContainer('params', message);
        } else {
          if (message.isAssignmentPattern()) {
            message = message.get('left');
          }

          message = message.node;
        }

        constructorPath.get('body.body').forEach(path => {
          try {
            const calleePath = path.get('expression.callee');

            if (calleePath.isSuper()) {
              calleePath.findParent(path => path.isExpressionStatement()).remove();
            }
          } catch (error) {// Handled
          }
        });
        constructorPath.get('body').unshiftContainer('body', body(message));
      }

    }
  };
});

export default index;
//# sourceMappingURL=index.js.map
